package com.ruoyi.demo.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.demo.entity.DlUser;
import com.ruoyi.demo.entity.MyPage;
import com.ruoyi.demo.entity.bo.PlanBo;
import com.ruoyi.demo.entity.vo.DlUserListVo;
import com.ruoyi.demo.mapper.DlUserMapper;
import com.ruoyi.demo.service.DlUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

@Service
@Transactional
public class DlUserServiceImpl implements DlUserService {
    @Autowired
    DlUserMapper dlUserMapper;

    @Override
    public MyPage<DlUserListVo> getList(PlanBo bo) {
        QueryWrapper<DlUser> queryWrapper = new QueryWrapper<>();
        if (bo.getText() != null)
            queryWrapper.and(dlUserQueryWrapper -> {
                dlUserQueryWrapper/*.like("user_id",bo.getText())
                    .or()*/
                    .like("user_name", bo.getText())
                    .or()
                    .like("user_telephone", bo.getText());
            });
        if (bo.getStartTime() != null) // 搜索开始时间小于等于最后接入时间
            queryWrapper.apply("end_time >= STR_TO_DATE({0},'%Y-%m-%d %H:%i:%s')", bo.getStartTime());
        if (bo.getEndTime() != null) // 搜索结束时间大于等于最后接入时间
            queryWrapper.apply("end_time <= STR_TO_DATE({0},'%Y-%m-%d %H:%i:%s')", bo.getEndTime());
        queryWrapper.eq("deleted", "0");
        Page<DlUser> page = new Page<>(bo.getPageNum(), bo.getPageSize());
        List<DlUser> dlUsers = dlUserMapper.selectPage(page, queryWrapper).getRecords();
        List<DlUserListVo> vos = new ArrayList<>();
        for (DlUser user : dlUsers) {
            vos.add(new DlUserListVo(user));
        }
        return new MyPage<>(page, vos);
    }
}
